commit 2a6bcfc2f141b9c3885cc18fe07e59becc09653e
Author: freddy77 <freddy77>
Date:   Tue Mar 2 15:41:37 2010 +0000

    add a test for SQLGetDescRec/SQLSetDescRec and fix a small issue in SQLGetDescRec

diff --git a/ChangeLog b/ChangeLog
index ca587e0..59b0344 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,10 @@
+Tue Mar  2 16:40:46 CET 2010    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/odbc/odbc.c src/odbc/unittests/.cvsignore:
+	* src/odbc/unittests/Makefile.am src/odbc/unittests/common.h:
+	* src/odbc/unittests/descrec.c:
+	- add a test for SQLGetDescRec/SQLSetDescRec and fix a small issue
+	  in SQLGetDescRec
+
 Tue Mar  2 16:06:34 CET 2010    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/odbc/unittests/common.c src/odbc/unittests/common.h:
 	* src/odbc/unittests/error.c src/odbc/unittests/getdata.c:
@@ -2352,4 +2359,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog-0.82 added because of release
 	
 $FreeTDS$
-$Id: ChangeLog,v 1.2997 2010/03/02 15:07:00 freddy77 Exp $
+$Id: ChangeLog,v 1.2998 2010/03/02 15:41:37 freddy77 Exp $
diff --git a/src/odbc/odbc.c b/src/odbc/odbc.c
index 0ef13fd..0546599 100644
--- a/src/odbc/odbc.c
+++ b/src/odbc/odbc.c
@@ -60,7 +60,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: odbc.c,v 1.529 2010/02/01 10:16:05 freddy77 Exp $");
+TDS_RCSID(var, "$Id: odbc.c,v 1.530 2010/03/02 15:41:37 freddy77 Exp $");
 
 static SQLRETURN _SQLAllocConnect(SQLHENV henv, SQLHDBC FAR * phdbc);
 static SQLRETURN _SQLAllocEnv(SQLHENV FAR * phenv, SQLINTEGER odbc_version);
@@ -2268,16 +2268,19 @@ SQLGetDescRec(SQLHDESC hdesc, SQLSMALLINT RecordNumber, SQLCHAR * Name, SQLSMALL
 	tdsdump_log(TDS_DBG_FUNC, "SQLGetDescRec(%p, %d, %p, %d, %p, %p, %p, %p, %p, %p, %p)\n", 
 			hdesc, RecordNumber, Name, BufferLength, StringLength, Type, SubType, Length, Precision, Scale, Nullable);
 
-	if (desc->type == DESC_IRD && desc->header.sql_desc_count) {
-		odbc_errs_add(&desc->errs, "HY007", NULL);
+	if (RecordNumber <= 0) {
+		odbc_errs_add(&desc->errs, "07009", NULL);
 		ODBC_RETURN(desc, SQL_ERROR);
 	}
 
-	if (RecordNumber > desc->header.sql_desc_count || RecordNumber <= 0) {
-		odbc_errs_add(&desc->errs, "07009", NULL);
+	if (desc->type == DESC_IRD && desc->header.sql_desc_count) {
+		odbc_errs_add(&desc->errs, "HY007", NULL);
 		ODBC_RETURN(desc, SQL_ERROR);
 	}
 
+	if (RecordNumber > desc->header.sql_desc_count)
+		ODBC_RETURN(desc, SQL_NO_DATA);
+
 	drec = &desc->records[RecordNumber - 1];
 
 	if ((rc = odbc_set_string(Name, BufferLength, StringLength, tds_dstr_cstr(&drec->sql_desc_name), -1)) != SQL_SUCCESS)
diff --git a/src/odbc/unittests/.cvsignore b/src/odbc/unittests/.cvsignore
index 37692f5..6fcba10 100644
--- a/src/odbc/unittests/.cvsignore
+++ b/src/odbc/unittests/.cvsignore
@@ -74,3 +74,4 @@ transaction2
 utf8
 utf8_2
 stats
+descrec
diff --git a/src/odbc/unittests/Makefile.am b/src/odbc/unittests/Makefile.am
index 5edf080..8675be9 100644
--- a/src/odbc/unittests/Makefile.am
+++ b/src/odbc/unittests/Makefile.am
@@ -1,4 +1,4 @@
-# $Id: Makefile.am,v 1.81 2009/12/15 11:23:47 freddy77 Exp $
+# $Id: Makefile.am,v 1.82 2010/03/02 15:41:37 freddy77 Exp $
 TESTS		=	\
 			t0001$(EXEEXT) t0002$(EXEEXT) t0003$(EXEEXT)\
 			t0004$(EXEEXT) connect$(EXEEXT) print$(EXEEXT)\
@@ -23,7 +23,7 @@ TESTS		=	\
 			attributes$(EXEEXT) hidden$(EXEEXT) blob1$(EXEEXT) \
 			cancel$(EXEEXT) wchar$(EXEEXT) rowset$(EXEEXT) transaction2$(EXEEXT) \
 			cursor6$(EXEEXT) cursor7$(EXEEXT) utf8$(EXEEXT) utf8_2$(EXEEXT) \
-			stats$(EXEEXT)
+			stats$(EXEEXT) descrec$(EXEEXT)
 
 check_PROGRAMS	=	$(TESTS)
 
@@ -91,6 +91,7 @@ cursor7_SOURCES	= cursor7.c common.c common.h
 utf8_SOURCES	= utf8.c common.c common.h
 utf8_2_SOURCES	= utf8_2.c common.c common.h
 stats_SOURCES	= stats.c common.c common.h
+descrec_SOURCES	= descrec.c common.c common.h
 
 AM_CPPFLAGS	=	-I$(top_srcdir)/include $(ODBC_INC) -DFREETDS_SRCDIR=\"$(srcdir)\"
 if MINGW32
diff --git a/src/odbc/unittests/common.h b/src/odbc/unittests/common.h
index 8c449cd..4b246f2 100644
--- a/src/odbc/unittests/common.h
+++ b/src/odbc/unittests/common.h
@@ -21,7 +21,7 @@
 #include <sql.h>
 #include <sqlext.h>
 
-static char rcsid_common_h[] = "$Id: common.h,v 1.31 2010/03/02 15:07:00 freddy77 Exp $";
+static char rcsid_common_h[] = "$Id: common.h,v 1.32 2010/03/02 15:41:37 freddy77 Exp $";
 static void *no_unused_common_h_warn[] = { rcsid_common_h, no_unused_common_h_warn };
 
 #ifndef HAVE_SQLLEN
@@ -149,6 +149,8 @@ SQLSMALLINT AllocHandleErrType(SQLSMALLINT type);
 	CHKR2(SQLProcedureColumns, (Statement,a,b,c,d,e,f,g,h), SQL_HANDLE_STMT, Statement, res)
 #define CHKColumns(a,b,c,d,e,f,g,h,res) \
 	CHKR2(SQLColumns, (Statement,a,b,c,d,e,f,g,h), SQL_HANDLE_STMT, Statement, res)
+#define CHKGetDescRec(a,b,c,d,e,f,g,h,i,j,res) \
+	CHKR2(SQLGetDescRec, (Descriptor,a,b,c,d,e,f,g,h,i,j), SQL_HANDLE_STMT, Descriptor, res)
 
 int Connect(void);
 int Disconnect(void);
diff --git a/src/odbc/unittests/descrec.c b/src/odbc/unittests/descrec.c
new file mode 100644
index 0000000..ed7a1b7
--- /dev/null
+++ b/src/odbc/unittests/descrec.c
@@ -0,0 +1,37 @@
+/* test SQLGetDescRec */
+#include "common.h"
+
+static char software_version[] = "$Id: descrec.c,v 1.1 2010/03/02 15:41:37 freddy77 Exp $";
+static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
+
+int
+main(void)
+{
+	SQLHDESC Descriptor;
+	SQLINTEGER ind;
+	SQLCHAR name[128];
+	SQLSMALLINT si;
+
+	use_odbc_version3 = 1;
+	Connect();
+
+	Command("create table #tmp1 (i int)");
+
+	/* get IRD */
+	CHKGetStmtAttr(SQL_ATTR_IMP_ROW_DESC, &Descriptor, sizeof(Descriptor), &ind, "S");
+
+	CHKGetDescRec(-1, name, sizeof(name), &si, NULL, NULL, NULL, NULL, NULL, NULL, "E");
+	/* TODO here should be NO_DATA cause we are requesting bookmark */
+	/* CHKGetDescRec(0, name, sizeof(name), &si, NULL, NULL, NULL, NULL, NULL, NULL, "No"); */
+	CHKGetDescRec(1, name, sizeof(name), &si, NULL /*Type*/, NULL /*SubType*/, NULL /*Length*/, NULL/*Precision*/,
+		      NULL /*Scale*/, NULL /*Nullable*/, "No");
+
+	Command("SELECT name FROM sysobjects");
+
+	CHKGetDescRec(1, name, sizeof(name), &si, NULL /*Type*/, NULL /*SubType*/, NULL /*Length*/, NULL/*Precision*/,
+		      NULL /*Scale*/, NULL /*Nullable*/, "S");
+
+	Disconnect();
+	return 0;
+}
+

